#! /bin/csh
#
# file call_codeco.csh
#      ===============
#
# version 3, 24-Aug-98
#
# Calls codeco from command line
# K. Stammler, 19-Aug-98

if  ("$4" == "")  then
	echo "Usage: $0 <inpfile> <infmt> <outfile> <outfmt>"
	exit
endif

#set echo

#set curpath=$0
#if  ("$curpath:h" == "$curpath")  then
#	set curpath=""
#else
#	set curpath=$curpath:h/..
#endif
#
#if  ($?CO_ROOT == 0)  then
#	if  ("$curpath" == "" || "$curpath" == "./")  then
#		setenv CO_ROOT ..
#	else
#		setenv CO_ROOT $curpath
#	endif
#endif

setenv CO_ROOT /gse/codeco/codeco3

setenv SEED_PROG $CO_ROOT/bin
setenv SH_ERRORS $CO_ROOT/fixed_bin/
setenv SEED_INPUTS $CO_ROOT/fixed_bin/seed_inputs/

# get parameters
set inpfile=$1
set infmt=$2
set outfile=$3
set outfmt=$4

# set constants
set codeco_inp=codeco_inp_$$.000
set codeco=$CO_ROOT/bin/codeco

# check parameters
if  (! -e $inpfile)  then
	echo "$0 : Cannot find input file $inpfile.  Abort."
	exit
endif
if  (-e $outfile)  \rm $outfile

if  (! -x $codeco)  then
	echo "Eecutable codeco not found.  Please complete installation."
	exit
endif

# parse outfmt
set tmp=`echo $outfmt | sed 's/-/ /g'`
set addpar=""
if  ($#tmp > 1)  then
	set outfmt=$tmp[1]
	set addpar=$tmp[2]
endif

if  (-e $codeco_inp)  \rm $codeco_inp
touch $codeco_inp
echo "$inpfile"   >>$codeco_inp
echo "$infmt"     >>$codeco_inp
echo "$outfile"   >>$codeco_inp
echo "$outfmt"    >>$codeco_inp
if  ("$addpar" != "")  then
	echo "$addpar" >>$codeco_inp
endif

$codeco <$codeco_inp >& /dev/null

\rm $codeco_inp
