#! /bin/csh
#
# file test.csh
#      ========
#
# version 2, 26-Nov-98
#
# Tests a list of GSE files
# K. Stammler, 19-Aug-98

# test for installation of SH:
set res=`alias SH`
if  ("$res" == "")  then
	echo "package SH not installed on your system. You can't run test now."
	exit
endif

set tlist = ( CLZ.GSE Y2000.GSE DAVOS.GSE GRB1.GSE LEAP.GSE ACC.GSE EX6.GSE )
#set tlist = ( CLZ.GSE )

# test conversions between GSE subformats
echo ""
echo "testing conversions between GSE subformats"
foreach t ($tlist)
	echo ""
	echo "testing file $t"
	codeco_cmp.csh $t gse cm6 intv-0
	\rm $t.cm6 $t.cm6.intv-0
	codeco_cmp.csh $t gse int cmp6-2
	\rm $t.int $t.int.cmp6-2
end

# test conversions to Mini-SEED
echo ""
echo "testing conversion to Mini-SEED"
foreach t ($tlist)
	echo ""
	echo "testing file $t"
	codeco_cmp.csh $t gse seed
	\rm *.[B,S]H[Z,N,E]
end

# test conversion to SAC and back
echo ""
echo "testing conversion to SAC and back"
foreach t ($tlist)
	echo ""
	echo "testing file $t"
	codeco_cmp.csh $t gse sac
	\rm $t.sac.cm6
end

# test conversion to CSS and back
echo ""
echo "testing conversion to CSS and back"
foreach t ($tlist)
	echo ""
	echo "testing file $t"
	codeco_cmp.csh $t gse css3
	# \rm $t.css.cm6
end
