c Some modifications by Karl Koch, 3 Dec. 1999
c------------------------------------------------------------------------------
c  Version 98.001 - 21.08.98
c==============================================================================
c     Karl Koch, 21.08.98
c
c     This file contains one subroutine: CSSOUT
c
c          *) CSSOUT ...  write CSS-waveform data
c
c==============================================================================
c
      subroutine cssout(iout,outfile,iy,iwf)
c------------------------------------------------------------------------------
c     Input/Output parameters:
c        iout ........ logical unit for output data
c        outfile ..... file name of .wfdisc file
c        iy .......... integer array to hold raw waveform data (see c_sigsize)
c        iwf.......... waveform identifier (iwaveform)
c
c        disabled
c        nmax
c------------------------------------------------------------------------------
c
      implicit none

      include 'codeco_common.f'

c     parameters
      integer*4 iout
      integer*4 iy(1)
      integer*4 iwf
      character outfile*(*)

c     local variables
c
      integer*4 UTM(5)
      integer*4 ioutw
      integer*4 trimlen
      integer*4 i,j,n
      real      fsec                ! seconds and milliseconds
      character outfilew*132,datestr*132
      character dot*64
      integer yearnow,jdaynow
      real*8 btime,etime
c
c     -- executable code

c     -- get current date
c     -- with routine idate, easy but not available on many systems
c      call idate(UTM)
c     -- with a dummy date, easy but not really convincing
c      utm(1) = 1
c      utm(2) = 1
c      utm(3) = 1980
c      utm(4) = 0
c      utm(5) = 0
c      call julien(utm(1),utm(2),utm(3),jdaynow,1)
c     -- calling system, not very elegant
      call unix_date( utm(3), jdaynow )
      call julien(utm(1),utm(2),utm(3),jdaynow,0)
c     --
      dot='.'
      yearnow=UTM(3)
c
c ----------  /*formatstring for version 2.8 wfdisc-file*/
228   format(1x,i4,i3.3,1x,f15.3,1x,a6,1x,a2,1x,i8,1x,f11.7,1x,f9.5,1x,
     &  f7.4,1x,a6,1x,a1,1x,a2,1x,a1,1x,i8,1x,i8,1x,a30,1x,a20,1x,i10,
     &  2x,i4,i3.3,1x,a30)
c ----------  /*formatstring for version 3.0 wfdisc-file*/
230    format(a6,1x,a8,1x,f17.5,1x,i8,1x,i8,2x,i4,i3.3,1x,f17.5,1x,i8,
     &  1x,f11.7,1x,f16.6,1x,f16.6,1x,a6,1x,a1,1x,a2,1x,a1,1x,a64,1x,
     &  a32,1x,i10,1x,i8,1x,a17)

c     -- adjust calibration factor to displacement
      if  (hdr_calunit .gt. 0)  then
c     -- divide cal.factor 'hdr_calunit' times by 2*pi/hdr_calper
         hdr_calfac = hdr_calfac / 
     &      (atan(1.0)*8.0/hdr_calper)**hdr_calunit
         hdr_calunit = 0
      endif

      UTM(1)=hdr_jday
      UTM(2)=hdr_hour
      UTM(3)=hdr_min
      UTM(4)=hdr_sec
      UTM(5)=hdr_msec
      call utmepo(hdr_year,UTM,btime)
      etime=btime+hdr_nsamp*hdr_smprate
      j=trimlen(outfile)
      do i=1,j
         if (outfile(i:) .eq. '.wfdisc') then
            j = i - 1
            if  (j .eq. 0)  j = 1
         endif
      enddo
      write(outfilew,'(2a,i3.3,a)') 
     1        outfile(1:j),'.',iwf,'.w'
       if (hdr_ofmtnum .eq. -11) then
          if (hdr_debug .gt.1) then
            print *, hdr_year,hdr_jday,btime,hdr_station,hdr_chan,
     1               hdr_nsamp,hdr_smprate,hdr_calfac,hdr_calper,
     2               hdr_instr,'o','s4','_',iwf,iwf,dot(1:30),outfilew,
     3               0,yearnow,jdaynow,'_'
          endif
          write(iout,228) hdr_year,hdr_jday,btime,hdr_station,hdr_chan,
     1            hdr_nsamp,hdr_smprate,hdr_calfac,hdr_calper,
     2            hdr_instr,'o','s4','_',iwf,iwf,dot(1:30),outfilew,
     3            0,yearnow,jdaynow,'_'
       else if (hdr_ofmtnum .eq. -12) then
          if (hdr_debug .gt.1) then
            print *, hdr_station,hdr_chan,btime,iwf,iwf,yearnow,
     1          jdaynow,etime,hdr_nsamp,hdr_smprate,hdr_calfac,
     2          hdr_calper,hdr_instr,'o','s4','_',dot,outfilew,0,0,'_'
          endif
          write(iout,230) hdr_station,hdr_chan,btime,iwf,iwf,
     1          yearnow,jdaynow,etime,hdr_nsamp,hdr_smprate,hdr_calfac,
     2          hdr_calper,hdr_instr,'o','s4','_',dot,outfilew,0,0,'_'
       else
           write(6,*) "unrecognized format in CSSOUT"
       endif
c
      ioutw=13 
      open(ioutw,file=outfilew,access='direct',form='unformatted',
     &     recl=4)
      do i=1,hdr_nsamp
         write(ioutw,rec=i) iy(i)
      enddo 

ckk  --- the follwoing would work faster, but is more cumbersome
ckk      open(ioutw,file=outfilew,access='direct',form='unformatted',
ckk     &     recl=512)
ckk      n=1
ckk      do i=1,hdr_nsamp,128
ckk         if (i+127 .gt. hdr_nsamp)  then
ckk           if (hdr_debug .gt. 4)
ckk     &       write(*,"('Data samples ',i,' to ',i,' written')")
ckk     &       i,j 
ckk           write(ioutw,rec=n) (iy(j),j=i,hdr_nsamp)
ckk         else
ckk           if (hdr_debug .gt. 4)
ckk     &       write(*,"('Data samples ',i,' to ',i,' written')")
ckk     &       i,j 
ckk           write(ioutw,rec=n) (iy(j),j=i,i+127)
ckk         endif
ckk         n=n+1
ckk      enddo 

      close(ioutw)
c
      return
      end
 

c------------------------------------------------------------------------------
c
      subroutine cssin(iin,iy,ierror)
c------------------------------------------------------------------------------
c     Input/Output parameters:
c        iin  ........ logical unit for input data (.wfdisc file)
c        iy .......... integer array to hold raw waveform data (see c_sigsize)
c        ierror ...... error code
c
c        disabled
c        nmax
c------------------------------------------------------------------------------
c
      implicit none

      include 'codeco_common.f'

c     parameters
      integer*4 iin
      integer*4 iy(1)
      integer*4 ierror

c     local variables
c
      integer*4 UTM(5)
      integer*4 iinw !,ioffset
      integer*4 trimlen
      integer*4 trimbeg
      integer*4 i,j,n,iwf1,iwf2
      integer*4 ioffset, joffset
      character infilew*132, infiledir*132,datestr*132
      character flag1*32, flag2*32, flag3*32, flag4*32
      character c_bytes*1
      character line*320
      integer yearthen,jdaythen
      real*8 btime,etime
c
c     -- executable code
c
c ----------  /*formatstring for version 2.8 wfdisc-file*/
228   format(1x,i4,i3.3,1x,f15.3,1x,a6,1x,a2,1x,i8,1x,f11.7,1x,f9.5,1x,
     &  f7.4,1x,a6,1x,a1,1x,a2,1x,a1,1x,i8,1x,i8,1x,a30,1x,a20,1x,i10,
     &  2x,i4,i3.3,1x,a30)
c ----------  /*formatstring for version 3.0 wfdisc-file*/
230    format(a6,1x,a8,1x,f17.5,1x,i8,1x,i8,2x,i4,i3.3,1x,f17.5,1x,i8,
     &  1x,f11.7,1x,f16.6,1x,f16.6,1x,a6,1x,a1,1x,a2,1x,a1,1x,a64,1x,
     &  a32,1x,i10,1x,i8,1x,a17)

      ierror=0
      read(iin,'(a)',err=19,end=22) line
      read(line,228,err=5) hdr_year,hdr_jday,btime,hdr_station,hdr_chan,
     1            hdr_nsamp,hdr_smprate,hdr_calfac,hdr_calper,hdr_instr,
     2            flag1,flag2,flag3,iwf1,iwf2,infiledir,infilew,
     3            ioffset,yearthen,jdaythen,flag4
      hdr_ifmtnum=-11
      if (hdr_debug .gt.1) then
         print *, 'Input waveforms in CSS 2.8 format'
         print *, hdr_year,hdr_jday,btime,hdr_station,hdr_chan,
     1            hdr_nsamp,hdr_smprate,hdr_calfac,hdr_calper,
     2            hdr_instr,flag1,flag2,flag3,iwf1,iwf2,infiledir,
     3            infilew,ioffset,yearthen,jdaythen,flag4
      endif
      goto 10

   5  read(line,230,err=20) hdr_station,hdr_chan,btime,iwf1,iwf1,
     1          yearthen,jdaythen,etime,hdr_nsamp,hdr_smprate,
     2          hdr_calfac,hdr_calper,hdr_instr,flag1,flag2,flag3,
     3          infiledir,infilew,ioffset,joffset,flag4
      hdr_ifmtnum=-12
      if (hdr_debug .gt.1) then
         print *, 'Input waveforms in CSS 3.0 format'
         print *, hdr_station,hdr_chan,btime,iwf1,iwf2,yearthen,
     1          jdaythen,etime,hdr_nsamp,hdr_smprate,hdr_calfac,
     2          hdr_calper,hdr_instr,flag1,flag2,flag3,infiledir,
     3          infilew,ioffset,joffset,flag4
      endif

   10 continue
      if (hdr_nsamp .eq.0 .or. hdr_smprate.eq. 0.0) goto 20
      if (flag2(1:2) .ne. 's4') then
         print *, 'Data representation ', flag2, 'not implemented'
         hdr_nsamp=0		! Nothing is read
         ierror=2
         return
      endif

      call epoutm(btime,hdr_year,UTM)
      hdr_jday=UTM(1)
      hdr_hour=UTM(2)
      hdr_min=UTM(3)
      hdr_sec=UTM(4)
      hdr_msec=UTM(5)
      call julien(hdr_day,hdr_month,hdr_year,hdr_jday,0)
c
      iinw=13 
      infiledir=infiledir(trimbeg(infiledir):trimlen(infiledir))

      open(iinw,file=infiledir(1:trimlen(infiledir))//'/'//infilew,
     1     access='direct',form='unformatted',recl=4)
      do i=1,hdr_nsamp
          read(iinw,rec=i+ioffset) iy(i)
      enddo

ckk  --- the follwoing would work faster, but is more cumbersome
ckk  --- and may not work anyway
ckk      open(iinw,file=infiledir(1:trimlen(infiledir))//'/'//infilew,
ckk     1     access='direct',form='unformatted',recl=512)
ckk      if (ioffset .gt. 0) then 
ckk         n=fix(ioffset/128)
ckk         ioffset=ioffset-n*128
ckk         if (ioffset .gt. 0) read(iinw,rec=n) (iy(j), j=1,128)
ckk         n=n+1
ckk         j=1
ckk         do i=ioffset+1,128
ckk            iy(j)=iy(i)
ckk            j=j+1
ckk         enddo
ckk         do i=j,hdr_nsamp,128
ckk            if (hdr_nsamp .lt. i+128) then
ckk               read(iinw,rec=n) (iy(j), j=i,hdr_nsamp)
ckk            else
ckk               read(iinw,rec=n) (iy(j), j=i,i+127)
ckk            endif
ckk            n=n+1
ckk         enddo
ckk      else
ckk         n=1
ckk         do i=1,hdr_nsamp,128
ckk            if (hdr_nsamp .lt. i+128) then
ckk               read(iinw,rec=n) (iy(j), j=i,hdr_nsamp)
ckk            else
ckk               read(iinw,rec=n) (iy(j), j=i,i+127)
ckk            endif
ckk            n=n+1
ckk         enddo
ckk      endif

      close(iinw)
      return
c
   19 write(6,*) "Error while reading a line in CSSIN"
   20 write(6,*) "Unrecognized format in CSSIN"
      print *, line
   22 continue
      ierror=99
      return
      end


c------------------------------------------------------------------
c
c    Subroutine returns year and julian day of today
c
c    Return values on error: if iyear/jday equal 
c       -3 ... temporary file for DATE output could not be opened
c       -1 ... error reading temporary file for DATE output

		subroutine unix_date(iyear, jday)
      integer iyear, jday

      call system('date ''+%Y %j''>/tmp/zyxwvutsr.0815007')
      open(24,file='/tmp/zyxwvutsr.0815007',status='old',err=998)
      read(24,*,err=999) iyear, jday
      call system('/bin/rm -f /tmp/zyxwvutsr.0815007')
      close(24)
      return
  998 iyear=-3
      jday=-3
      return
  999 iyear=-1
      jday=-1
      return
      end

c-----------------------------------------------------------------
